/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exercise.one;
import java.awt.*;        
import java.awt.event.*;  
import static java.lang.Integer.parseInt;
/**
 *
 * @author ardito
 */
public class AWTCountdown extends java.awt.Frame {

    private Label lblCount;    // Declare a Label component
    private TextField tfCount; // Declare a TextField component
    private Button btnCount;   // Declare a Button component
    private int count = 0;     // Counter's value
    
    public AWTCountdown() {
//        initComponents();
        setLayout(new FlowLayout());
         // "super" Frame, which is a Container, sets its layout to FlowLayout to arrange
         // the components from left-to-right, and flow to next row from top-to-bottom.

        lblCount = new Label("Counter");  // construct the Label component
        add(lblCount);                    // "super" Frame container adds Label component

        tfCount = new TextField(""+count, 10); // construct the TextField component with initial text
        tfCount.setEditable(true);       // set to read-only
        add(tfCount);                     // "super" Frame container adds TextField component

        btnCount = new Button("Countdown");   // construct the Button component
        add(btnCount);                    // "super" Frame container adds Button component

        BtnCountListener listener = new BtnCountListener();
        btnCount.addActionListener(listener);
           // "btnCount" is the source object that fires an ActionEvent when clicked.
           // The source object adds an instance of BtnCountListener as an ActionEvent listener,
           //   which provides an ActionEvent handler called actionPerformed().
           // Clicking "Count" button calls back actionPerformed().

        setTitle("AWT Countdown");  // "super" Frame sets its title
        setSize(300, 100);        // "super" Frame sets its initial window size

        // For inspecting the Container/Components objects
        // System.out.println(this);
        // System.out.println(lblCount);
        // System.out.println(tfCount);
        // System.out.println(btnCount);
        setVisible(true);         // "super" Frame shows
        // System.out.println(this);
        // System.out.println(lblCount);
        // System.out.println(tfCount);
        // System.out.println(btnCount);
        
        //        close windows
        addWindowListener(new WindowAdapter(){  
            public void windowClosing(WindowEvent e) {  
                dispose();  
            }  
        });  
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Exit the Application
     */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        AWTCountdown app = new AWTCountdown();
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new AWTCounter().setVisible(true);
//            }
//        });
    }

    private class BtnCountListener implements ActionListener {
      // ActionEvent handler - Called back upon button-click.
      @Override
      public void actionPerformed(ActionEvent evt) {
         count = parseInt(tfCount.getText());
         --count; // Increase the counter value
         // Display the counter value on the TextField tfCount
         tfCount.setText(count + ""); // Convert int to String
      }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
